//<c>   Copyright 1997-2000 by Gerry J. Danen; all rights reserved.

//<t>   Check number of decimals in win.ini
//              [intl]
//              iCurrDigits=2
//              iDigits=2

#include"gd_tools.h"
#include"gd_nw.h"


#define pgVERS_ "V1.20"
#define pgTITL_ "Set Number of Decimals in [intl] Section of WIN.INI to 2"
#define pgCOPR_ "1997"


UCHAR   iniSec[]="intl", iniFile[]="WIN.INI", iFile[FS_LEN], oFile[FS_LEN],
        work[1001], work1[1001] ;

int     iCurrDigits = -1234 ;
int     iDigits = -1234 ;


void    chkdec( STRING fn, int *iField )
{
    static char s[1025] ;
    int         n, xcnt=0 ;

    fl_parse_ini( iniFile, iniSec, fn, work, &xcnt );
    n = atoi(work);
    *iField = n ;

//printf( "%s = [%s]\n", fn, work );

    if ( ! strlen(work) )
    {
        sprintf( s, "! \"%s\" not found in [%s] section of %s", fn, iniSec, iniFile );
        nw_logmsg( s );
        *iField = -1 ;
        return ;
    }
    if ( n == 2 )
    {
        return ;
    }
    sprintf( s, "$ \"%s\" is not 2, but %d", fn, n );
    nw_logmsg( s );
    *iField = -2 ;
}


void    fix_ini_file( void )
{
    UCHAR       iniBak[]="WIN.DI$", sectionID[81], *w,
                f1[]="iCurrDigits", f2[]="iDigits" ;
    FILE        *iFh, *oFh ;
    BOOL        ynInserting = FALSE, inSection = FALSE, ynUpdated = FALSE ;

    if ( iCurrDigits == -1 || iDigits == -1 )
        ynInserting = TRUE ;

    fl_delete( iniBak );
    fl_rename( iniFile, iniBak );

    if ( ( iFh = fopen( iniBak, "r" ) ) == NULL )
    {
        sprintf( work, "$ %s failed to update %s (could not open %s)",
                 get_global_program_name(), iniFile, iniBak );
        nw_logmsg( work );
        fl_rename( iniBak, iniFile );
        exit( BAD_EXIT );
    }

    if ( ( oFh = fopen( iniFile, "w" ) ) == NULL )
    {
        sprintf( work, "$ %s failed to update %s (could not open %s)",
                 get_global_program_name(), iniFile, iniFile );
        nw_logmsg( work );
        fl_rename( iniBak, iniFile );
        exit( BAD_EXIT );
    }

    sprintf( sectionID, "[%s]", iniSec );

    while ( fgets( work, (sizeof(work)-1), iFh ) )
    {
        st_trim( work );
        if ( work[0] == '[' )
        {
            inSection = FALSE ;
            if ( st_eq(work, sectionID) )
                inSection = TRUE ;
        }

        if ( inSection )                        // see if we need to fix
        {
            strcpy( work1, work );
            w = strchr( work1, '=' );
            if ( w != NULL )
                *w = EOS ;
            if ( st_eq(work1, f1) )
            {
                sprintf( work, "%s=2", f1 );
                ynUpdated = TRUE ;
            }
            if ( st_eq(work1, f2) )
            {
                sprintf( work, "%s=2", f2 );
                ynUpdated = TRUE ;
            }
        }

        fprintf( oFh, "%s\n", work );           // write the line back out

        if ( inSection )                        // see if we need to insert
        {
            if ( iCurrDigits == -1 )
            {
                fprintf( oFh, "%s=2\n", f1 );
                iCurrDigits = 2 ;
                ynUpdated = TRUE ;
            }
            if ( iDigits == -1 )
            {
                fprintf( oFh, "%s=2\n", f2 );
                iDigits = 2 ;
                ynUpdated = TRUE ;
            }
        }
    }

    fcloseall();

    if ( ynUpdated )                            // feedback re update action
    {
        sprintf( work, "! %s updated %s", get_global_program_name(), iniFile );
        nw_logmsg( work );
        printf( "%s updated successfully\n", iniFile );
    }
}


void    main( int argc, char *argv[] )
{
    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    logon(0);

    if ( ! fl_exist( iniFile) )
    {
        logon(1);
        printf( "Can't find %s.\a\n", iniFile );
        exit( BAD_EXIT );
    }

    chkdec( "iCurrDigits", &iCurrDigits );
    chkdec( "iDigits", &iDigits );

    if ( iCurrDigits != 2 || iDigits != 2 )
        fix_ini_file();

    exit( GOOD_EXIT );
}
